/******************************************************************************
 *	flmain.c:		t@C̃Tv
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 *
 *	@\:
 *	^XN}gpăt@C̃Rs[At@CύXit@C̈ړjA
 *	t@C̍폜AfBNg̍쐬AfBNg̍폜s܂B
 *	t@CȂǂ̓͂ɂ́A_CAOgpē͂𑣂܂B
 *	͂ꂽt@C̃t@C݂̑Ȃǂ𒲂ׁAɓK؂ȃG[_C
 *	AO̕\Ȃǂs܂B
 *
 *	gp@:
 *	t@C.xN܂B
 *	̂ƂEBhEɂ͉\܂B
 *	j[ŏ]̃t@CI܂B
 *	IƂ̏ɕKvȃt@CȂǂ̓͂𑣂_CAO{bNX
 *	\܂B
 *	͂Ƃ́A[s]{^Ɠ͂ɂďA[]
 *	{^Ə܂B
 *	t@CȂǂ̓tpXŎw肵ĂB
 *	t[XO܂ł̃t@C܂ł͂ł܂B
 *	܂A_CAOł̓^[L[[s]{^AGXP[vL[[]
 *	{^ɂȂ悤Ă܂B
 */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <sxmemory.h>		/* }𗘗pƂɕKv	*/
#include <event.h>		/* Cxg}𗘗pƂɕKv	*/
#include <sxgraph.h>		/* Otn}l[W𗘗pƂɕKv */
#include <window.h>		/* EBhE}𗘗pƂɕKv	*/
#include <menu.h>		/* j[}𗘗pƂɕKv	*/
#include <dialog.h>		/* _CAO}𗘗pƂɕKv	*/
#include <text.h>		/* eLXg}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "file.h"		/* ̃vOŗL̃wb_t@C	*/

char _sxkernelcomm[] = SXKERNEL;	/* J[lNR}h		*/

/******************************************************************************
 *	main():		C֐
 ******************************************************************************
 */
int main(void)
{
	ComVal cv;			/* ʕϐ			*/

	if (!init(&cv)) {		/* s		*/
		showErrDialog(&cv);	/* G[_CAO\	*/
		cv.endFlag = TRUE;	/* ItOZbg	*/
	}
	/* ItOZbg܂Ń[v */
	while (!cv.endFlag) {
		cv.errorCode = 0;	/* G[R[hNA	*/
		/* ^XN}Cxg擾 */
		TSEventAvail(cv.eventMask, &cv.event);
		/* JgOtɂ */
		GMSetGraph(&cv.windowPtr->graph);

		/* eCxgɑΉs */
		switch (cv.event.ts.what) {
		case E_MSLDOWN:		/* }EXtg_ECxg	*/
			msLDownEvent(&cv);
			break;
		case E_MSRDOWN:		/* }EXCg_ECxg	*/
			msRDownEvent(&cv);
			break;
		case E_KEYDOWN:		/* L[_ECxg		*/
			keyDownEvent(&cv);
			break;
		case E_UPDATE:		/* Abvf[gCxg		*/
			updateEvent(&cv);
			break;
		case E_ACTIVATE:	/* ANeBx[gCxg	*/
			activateEvent(&cv);
			break;
		case E_SYSTEM1:		/* VXeCxg		*/
		case E_SYSTEM2:
			systemEvent(&cv);
			break;
		}
		if (cv.errorCode != 0)	/* G[H		*/
			showErrDialog(&cv); /* G[_CAO\ */
	}
	/* I葱s */
	endProc(((cv.errorCode == 0) ? EXIT_SUCCESS : EXIT_FAILURE), &cv);

	return 0;
}

/******************************************************************************
 *	init():		
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  
 *				= FALSE: siIj
 *	:	ʕϐ̏AA{[g֐̓o^AEBhE̍쐬
 *		\ȂǂsB
 */
BOOLEAN init(ComVal *pcv)
{
	pcv->windowPtr = NULL;		/* EBhE|C^		*/
	pcv->activeFlag = FALSE;	/* ANeButO		*/
	pcv->eventMask = EVENTMASK;	/* Cxg}XN		*/
	pcv->errorCode = 0;		/* G[R[h			*/
	pcv->endFlag = FALSE;		/* ItO			*/
	pcv->resFile = NULL;		/* \[Xt@Cւ̃nh	*/

	TSSetAbort(endProc, (long) pcv); /* A{[g֐o^	*/

	if (LOWWORD(SXVer()) < SXVER2) { /* rwVXẽo[W𒲂ׂ */
		pcv->errorCode = 1;	/* o[WQÂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}
	if (!openResource(pcv))		/* \[Xt@CI[v */
		/* I[vłȂ	*/
		return FALSE;		/* ŝFALSEԂ	*/

	if (!createWindow(pcv)) {	/* EBhE쐬		*/
		pcv->errorCode = 2;	/* 쐬łȂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}

	GMSetGraph(&pcv->windowPtr->graph); /* JgOtɂ */
	GMForeColor(G_BLACK);		/* tHAOEhJ[ɂ */
	/* obNOEhJ[CgO[ɂ */
	GMBackColor(G_LGRAY);

	WMShow(pcv->windowPtr);		/* EBhE\		*/
	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	openResource():	\[Xt@C̃I[v
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  ǂݍݐ
 *				= FALSE: ǂݍݎsiIj
 */
BOOLEAN openResource(ComVal *pcv)
{
	int errCode;			/* G[R[h			*/
	Task task;			/* ^XNǗR[h		*/
	char drv[2], path[65], node[19], ext[5];
	char name[23], fileName[TS_NAMEMAX];

	TSGetTdb(&task, TS_OWN);	/* ^XNǗR[h擾	*/
	strsfn(task.name, drv, path, node, ext); /* ^XN𕪉	*/
	strcpy(name, node);		/* \[Xt@C쐬	*/
	strcat(name, ".LB");
	strmfn(fileName, drv, path, "", ""); /* pX쐬	*/
	/* \[Xt@C */
	errCode = TSSearchFile(name, fileName, fileName);
	if (errCode < 0) {
		pcv->errorCode = 11;	/* tȂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}
	/* \[Xt@CI[v */
	pcv->resFile = TSResOpen(fileName);
	if (pcv->resFile == NULL) {
		pcv->errorCode = 12;	/* I[vłȂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}
	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	createWindow():	EBhE̍쐬
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬siIj
 */
BOOLEAN createWindow(ComVal *pcv)
{
	int paramFlags;			/* p[^̗L		*/
	Rect rc;
	Task task;			/* ^XNǗR[h		*/

	static Rect winSize = { 0, 0, WIN_H, WIN_V }; /* EBhETCY */

	TSGetTdb(&task, TS_OWN);	/* ^XNǗR[h擾	*/
	paramFlags = TSTakeParam(	/* R}hC͂	*/
		task.command,		/* R}hC		*/
		&rc,			/* w肳ꂽEBhEʒu	*/
		NULL,			/* ŏIi[Ȃ	*/
		0,			/* AhXe[uۑȂ	*/
		NULL,			/* AhXe[u쐬Ȃ	*/
		NULL);			/* |C^mۂȂ		*/
	if (!(paramFlags & 1)) {	/* EBhEʒu̎w肪邩H */
		/* ȂꍇAVXeEBhE̍W擾 */
		rc = winSize;
		GMSlideRect(&rc, TSGetWindowPos());
	}

	pcv->windowPtr = WMOpen(	/* EBhEI[v	*/
		NULL,			/* EBhE|C^mۂ	*/
		&rc,			/* EBhE̕\ʒu		*/
		WINTITLE,		/* EBhE^Cg		*/
		FALSE,			/* I[vɕ`悵Ȃ	*/
		WI_STD2 << 4,		/* ^Cg̍LWEBhE	*/
		W_FRONT,		/* ԎOɕ\		*/
		TRUE,			/* N[Y{^gp	*/
		TSGetID());		/* ̃^XNhc		*/
	if (pcv->windowPtr == NULL)
		return FALSE;		/* ŝFALSEԂ	*/

	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	msLDownEvent():	}EXtg_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:
 *	EBhEŃ}EX̍{^ꂽꍇ̏sB
 *	̏ŃN[Y{^ɂIAEBhËړ\ƂȂ܂B
 */
void msLDownEvent(ComVal *pcv)
{
	int partCode;			/* EBhẼp[gR[h	*/
	Window *wTemp;			/* e|EBhE|C^	*/

	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		/* EBhECANeBuŁAOPT.1L[ĂȂH */
		if (!pcv->activeFlag && !(pcv->event.ev.how & KS_OPT1)) {
			/* EBhEANeBuɂ */
			WMSelect(pcv->windowPtr);
			/* {^ꂽꏊ̃p[gR[h擾 */
			partCode = WMFind(pcv->event.ev.where.x_y, &wTemp);
			/* ^Cgo[ȊOA{^ꂽH */
			if (partCode != W_INDRAG || !EMLStill())
				return;
		}
		/* }EX̃{^ĂԁAEBhE̊e폈
		   VXeɔCāA{^ꂽA܂͗ꂽꏊ
		   p[gR[h擾 */
		partCode = SXCallWindM(pcv->windowPtr, &pcv->event);
		if (partCode == W_INCLOSE) /* N[Y{^H	*/
			pcv->endFlag = TRUE; /* ItOZbg	*/
	}
}

/******************************************************************************
 *	msRDownEvent():	}EXCg_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	EBhEŃ}EX̉E{^ꂽꍇ̏sB
 */
void msRDownEvent(ComVal *pcv)
{
	/* Cxg̃EBhEŁA
	   EBhEANeBuAOPT.1L[ꂽH */
	if (pcv->event.ev.whom.win == pcv->windowPtr
	 && (pcv->activeFlag || pcv->event.ev.how & KS_OPT1))
		selectMenu(pcv);	/* j[̍쐬ƑIs */
}

/******************************************************************************
 *	selectMenu():	|bvAbvj[̍쐬ƑI
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void selectMenu(ComVal *pcv)
{
	int num;			/* j[̃ACeԍ	*/
	Menu **menuHdl;			/* j[nh		*/

	static char str[] = {		/* j[`		*/
		"^Ct@C̃Rs[,"
		"^Ht@CύX,"
		"^Dt@C̍폜,"
		"^MfBNg쐬,"
		"^RfBNg폜"
	};

	menuHdl = MNConvert(		/* j[쐬		*/
		NULL,			/* j[nhmۂ	*/
		str,			/* j[`		*/
		MI_PLN);		/* ^Cg̃\[Xhc	*/
	if (menuHdl == NULL) {
		pcv->errorCode = 6;	/* 쐬łȂ		*/
		pcv->endFlag = TRUE;	/* ItOZbg	*/
		return;
	}
	num = MNSelect(			/* j[̕\ƑIs	*/
		menuHdl,		/* j[nh		*/
		pcv->event.ev.where.x_y); /* }EX̉E{^ꂽʒu */
	MMHdlDispose(menuHdl);		/* j[nh	*/
	switch (num) {
	case IDM_COPY:			/* t@C̃Rs[		*/
		copyProc(pcv);
		break;
	case IDM_RENAME:		/* t@CύX		*/
		renameProc(pcv);
		break;
	case IDM_DELETE:		/* t@C̍폜		*/
		deleteProc(pcv);
		break;
	case IDM_MKDIR:			/* fBNg쐬		*/
		mkdirProc(pcv);
		break;
	case IDM_RMDIR:			/* fBNg폜		*/
		rmdirProc(pcv);
		break;
	}
}

/******************************************************************************
 *	keyDownEvent():	L[_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	j[̃V[gJbgƁAOPT.1+'Q'L[ł̏IsB
 */
void keyDownEvent(ComVal *pcv)
{
	int shortCut;			/* V[gJbgL[		*/

	if (pcv->event.ev.how & KS_OPT1) { /* OPT.1L[ꂽH	*/
		/* L[͂啶ɕϊ */
		shortCut = toupper((int) pcv->event.ev.whom.key.ascii);
		switch (shortCut) {
		case 'Q':		/* I				*/
			pcv->endFlag = TRUE; /* ItOZbg	*/
			break;
		/* j[̃V[gJbgɑΉ */
		case 'C':		/* t@C̃Rs[		*/
			copyProc(pcv);
			break;
		case 'H':		/* t@CύX		*/
			renameProc(pcv);
			break;
		case 'D':		/* t@C̍폜		*/
			deleteProc(pcv);
			break;
		case 'M':		/* fBNg쐬		*/
			mkdirProc(pcv);
			break;
		case 'R':		/* fBNg폜		*/
			rmdirProc(pcv);
			break;
		}
	}
}

/******************************************************************************
 *	updateEvent():	Abvf[g
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:
 *	Abvf[gƂăEBhE`悷B
 *	̏sȂƁA艺̃EBhẼAbvf[gACh
 *	Cxg̏łȂȂ܂B
 */
void updateEvent(ComVal *pcv)
{
	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		WMUpdate(pcv->windowPtr); /* Abvf[gJn	*/
		WMUpdtOver(pcv->windowPtr); /* Abvf[gI	*/
	}
}

/******************************************************************************
 *	activateEvent():	ANeBx[gCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	ANeBuACANeBuɂANeButO̐؂ւƁA
 *		Cxg}XN̐؂ւsB
 */
void activateEvent(ComVal *pcv)
{
	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		pcv->activeFlag = TRUE;	/* ANeButOZbg	*/
		/* ANeBũCxg}XNZbg */
		pcv->eventMask = EVENTMASK | EM_KEYDOWN;
	/* Cxg̃EBhEŁAANeBuԂH */
	} else if (pcv->activeFlag) {
		pcv->activeFlag = FALSE; /* ANeButONA */
		/* CANeBũCxg}XNZbg */
		pcv->eventMask = EVENTMASK;
	}
}

/******************************************************************************
 *	systemEvent():	VXeCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	SEBhẼN[YAS^XN̏IAEBhẼZNg
 *		ΉsB
 */
void systemEvent(ComVal *pcv)
{
	int errCode;			/* G[R[h			*/

	switch (pcv->event.ts.what2) {	/* Cxg̎ނ́H		*/
	case CLOSEALL:			/* SEBhẼN[Y	*/
	case ENDTSK:			/* S^XN̏I		*/
		pcv->endFlag = TRUE;	/* ItOZbg	*/
		break;
	case WINDOWSELECT:		/* EBhẼZNg		*/
		WMSelect(pcv->windowPtr); /* EBhEANeBuɂ */
		break;
	case NOTICEEJECT:		/* fBXNCWFNg̗\	*/
		errCode = TSResLoad();	/* \[Xt@C[h	*/
		if (errCode < 0) {
			pcv->errorCode = 13; /* [hłȂ	*/
			/* CWFNgĂ͍̂ŃCxg揜 */
			TSGetEvent(pcv->eventMask, &pcv->event);
		}
		break;
	}
}

/******************************************************************************
 *	showErrDialog():	G[_CAO̕\
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void showErrDialog(ComVal *pcv)
{
	int i;

	static struct {			/* G[			*/
		int code;		/* G[R[h			*/
		int manager;		/* gp}l[W		*/
		int flag;		/* \tbO			*/
		char *message;		/* G[bZ[W		*/
	} errInfo[] = {
		{   1, 1, D_RED,    "SX SYSTEM̃o[WႢ܂B" },
		{   2, 2, D_RED,    "EBhE쐬ł܂B" },
		{   6, 1, D_RED,    "j[쐬ł܂B" },
		{   7, 1, D_YELLOW, "_CAO쐬ł܂B" },
		{  11, 2, D_RED,    "\[Xt@Ct܂B" },
		{  12, 2, D_RED,    "\[Xt@CI[vł܂B" },
		{  13, 2, D_YELLOW, "\[Xt@Cǂݍ߂܂B" },
		{  14, 1, D_YELLOW, "\[X̓ǂݍ݂Ɏs܂B" },
		{  15, 1, D_YELLOW, "hCȕłĂ܂B" },
		{  16, 1, D_YELLOW, "CgveNgĂ܂B\r"
				    "݂sƂł܂B" },
		{  -2, 1, D_YELLOW, "w肵t@Ct܂B" },
		{  -3, 1, D_YELLOW, "w肵fBNg\r"
				    "t܂B" },
		{  -4, 1, D_YELLOW, "I[vĂt@C\r"
				    "܂B" },
		{  -5, 1, D_YELLOW, "fBNg{[x\r"
				    "ANZXł܂B" },
		{ -13, 1, D_YELLOW, "t@C̎wɌ肪܂B" },
		{ -15, 1, D_YELLOW, "hCuwɌ肪܂B" },
		{ -19, 1, D_YELLOW, "̃t@C͏݂ł܂B" },
		{ -20, 1, D_YELLOW, "̃fBNg͂łɑ݂܂B" },
		{ -21, 1, D_YELLOW, "t@Ĉ݂\r"
				    "폜ł܂B" },
		{ -22, 1, D_YELLOW, "̃t@C͂łɑ݂܂B" },
		{ -23, 1, D_YELLOW, "fBXNς\r"
				    "t@C쐬ł܂B" },
		{ -24, 1, D_YELLOW, "fBNgς\r"
				    "t@C쐬ł܂B" },
		{   0, 1, D_YELLOW, "G[܂B" }
	};

	for (i = 0; errInfo[i].code != 0; i++) /* G[R[h{	*/
		if (errInfo[i].code == pcv->errorCode)
			break;
	switch (errInfo[i].manager) {	/* }l[W̑I		*/
	case 1:				/* _CAO}		*/
		DMError(errInfo[i].flag | D_CONFIRM, errInfo[i].message);
		break;
	case 2:				/* ^XN}			*/
		TSErrDialogN(errInfo[i].flag | D_CONFIRM, errInfo[i].message);
		break;
	}
}

/******************************************************************************
 *	endProc():	I葱
 ******************************************************************************
 *	:	int code	IR[h
 *		ComVal *pcv	ʕϐւ̃|C^
 *	:	nh̉EBhE̔pƁAvȌIsB
 */
void endProc(int code, ComVal *pcv)
{
	/* EBhE|C^mۂꂽ܂܂H */
	if (pcv->windowPtr != NULL)
		WMDispose(pcv->windowPtr); /* EBhEp	*/
	/* \[Xt@Cւ̃nhmۂꂽ܂܂H */
	if (pcv->resFile != NULL)
		TSResRemove();		/* Jg\[Xt@Cp */

	exit(code);			/* vOI		*/
}
